uses MIDIDrv, Crt, Dos;
var
  MIDI_File: file;
  MIDI_Size: word;
  MIDI_Data: pointer;
  port,i : integer;
  DirInfo: SearchRec;

begin
  writeln;
  writeln('MIDI Player - By Prudnikov Maxim (Mc0deR), MTM, 1996 year.');
  writeln('Playing MID files on SB V1.00, V1.50, V2.00, SB Pro, Adlib.');
  writeln;
  if (ParamCount = 0)or(ParamCount > 2) then begin
    writeln('Usage       : MidPlay.exe <filename.mid> [port number]');
    writeln('For Example : MidPlay jazzz.mid $250');
    writeln('Default port number - $220. WARRING - for type port - usage "$"');
    writeln;
    halt;
  end;

  if (ParamCount = 2) then Val(paramstr(2), port, i) else port := $220;

  FindFirst(paramstr(1), Archive, DirInfo);
  if (DirInfo.Name = '') then begin
    writeln('File "', paramstr(1), '" not found.');
    writeln;
    halt;
  end;

  writeln('Press any key to abort playing.');
  writeln('Playing file "', DirInfo.Name, '"...');

  MIDISetPort(port, 0);
  MIDIInit(0);
  Assign(MIDI_File, DirInfo.Name);
  Reset(MIDI_File, 1);
  MIDI_Size := FileSize( MIDI_File );
  GetMem( MIDI_Data, MIDI_Size);
  blockread( MIDI_File, MIDI_Data^, MIDI_Size );
  close( MIDI_File );

  repeat
    if MIDIStatus = 0 then MIDIPlay( MIDI_Data );
  until Keypressed;
  ReadKey;
  MIDIUnInit;
  FreeMem( MIDI_Data, MIDI_Size);
  writeln('Playing aborted.');
end.
